<template>
  <div>
    <RouterView v-if="moduleIsReady" />
    <b-row v-else align-h="center" class="my-4">
      <b-spinner variant="primary" />
    </b-row>
  </div>
</template>

<script lang="ts">
// import the store for current module
import useProjectStore from "./store";
import useResourceStore from "@/modules/resource/store";
import useNotificationStore from "@/store/notification";

import type { RouteLocationNormalized } from "vue-router";
import type { ProjectDto } from "@coscine/api-client/dist/types/Coscine.Api";

export default defineComponent({
  async beforeRouteUpdate(to, from, next) {
    await this.apiFetch(to);
    next();
  },
  setup() {
    const projectStore = useProjectStore();
    const notificationStore = useNotificationStore();
    const resourceStore = useResourceStore();

    return { projectStore, notificationStore, resourceStore };
  },

  computed: {
    project(): ProjectDto | null {
      return this.projectStore.currentProject;
    },
    moduleIsReady(): boolean {
      return (
        this.projectStore.currentSlug !== null &&
        this.projectStore.currentProject !== null &&
        this.projectStore.currentResources !== null &&
        this.projectStore.currentSubProjects !== null &&
        this.projectStore.currentProjectRoles !== null &&
        this.projectStore.roles !== null &&
        this.projectStore.roles !== undefined &&
        this.resourceStore.enabledResourceTypes !== null
      );
    },
  },

  mounted() {
    this.initialize();
  },

  methods: {
    async initialize() {
      await this.apiFetch(this.$router.currentRoute.value);
    },

    async apiFetch(route: RouteLocationNormalized) {
      const otherPromises: Promise<void>[] = [];
      // Load All Projects if not present
      if (this.projectStore.allProjects === null) {
        otherPromises.push(this.projectStore.retrieveAllProjects());
      }
      // Load list of all Project Role Types if not present
      if (this.projectStore.roles === null) {
        otherPromises.push(this.projectStore.retrieveRoles());
      }

      // Project may be unset (e.g. when entering from a direct link)
      await this.projectStore.retrieveUnsetProject(this.project, route);
      // Load Resources for the project if not present
      if (this.projectStore.currentResources === null) {
        otherPromises.push(this.projectStore.retrieveResources(this.project));
      }
      // Load Project Roles for the project if not present
      if (this.projectStore.currentProjectRoles === null) {
        await this.projectStore.retrieveProjectRoles(this.project);
      }

      // Load Invitations for the project if not present
      if (
        this.projectStore.currentInvitations === null &&
        this.projectStore.currentUserRoleIsOwner
      ) {
        otherPromises.push(this.projectStore.retrieveInvitations(this.project));
      }
      // Load list of Available Resource Types for the project if not present
      otherPromises.push(
        this.resourceStore.retrieveAvailableResourceTypesInformationForProject(
          this.project,
        ),
      );

      await Promise.all(otherPromises);
    },
  },
});
</script>
